%   [magnitude, direction] = rcmgmex(image_in,mask_size,s)
%
%   This mex file finds the Robust Colour Morphological Gradient, as detailed in 
%   A.N. Evans and X.U. Liu, A Morphological Gradient Approach to Color Edge Detection, 
%   IEEE Transactions on Image Processing, 15(6), pp. 1454-1463, June 2006.
%
%   This implementation uses the combined distance metric
%
%   Output arguments:
%       magnitude -- the edge magnitude
%       direction -- the associated edge direction, radians
%
%   Input arguments:
%       image_in -- a multichannel image of size rows x cols x channels
%       mask_size -- should be odd integer (default 3)
%       s -- the number of vector pairs to reject (default 0)

